/**
Copyright Philipp Tölke, 2006-2007 {{{

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License version 2 as published by the Free
Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
St, Fifth Floor, Boston, MA  02110-1301  USA
}}} **/

#include <string.h>
#include <stdio.h>

#include "pathhandler.h"

#ifdef _WIN32
#define PATHSEP '\\'
#define L 1
#else
#define PATHSEP '/'
#define L 0
#endif

const char* getFullOutFile(const char* infile, char* outfilename, char* outfilepath) { // {{{

    char * realoutfile;
    int l = strlen(outfilepath);
    if ( l > 0 && outfilepath[l-1] == PATHSEP) { // -> The User has supplied a directory, no file
        realoutfile = new char[l+strlen(outfilename)+1];
        strncpy(realoutfile, outfilepath, l);
    } else if (outfilepath[0] != '\0') { // -> The User supplied something
        realoutfile = new char[l+1];
        strcpy(realoutfile, outfilepath);
        return realoutfile;
    } else {
        int i;
        bool one=true;
        for (i = strlen(infile)-1; i>=0; i--) {
            if(infile[i]==PATHSEP) {
                if (one)
                    one=false;
                else
                    break;
            }
        }
        l=i+1;
        realoutfile = new char[l+strlen(outfilename)+1];
        //Copy the path
        strncpy(realoutfile, infile, l);
    }

    strcpy(realoutfile+l, outfilename);

    return realoutfile;
}
//}}}
