/**
Copyright Philipp Tölke, 2006-2007

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License version 2 as published by the Free
Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
St, Fifth Floor, Boston, MA  02110-1301  USA
**/

#include "tiffoutfile.h"
#include "error.h"

TIFFOutfile::TIFFOutfile() {}

int TIFFOutfile::initialize(const char* outfilename, struct jpeg_error_mgr* jerr, JDIMENSION width, JDIMENSION height, int components, J_COLOR_SPACE cs) {
    tif = TIFFOpen(outfilename, "w");

    if (!tif) {
        return OUTFILENOTFOUND;
    }

    TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, width);
    //TIFFSetField(tif, TIFFTAG_IMAGELENGTH, height);
    TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, 8);
    TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, components);
    TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);

    row=0;

    return 0;
}

TIFFOutfile::~TIFFOutfile() {
}

void TIFFOutfile::destroy() {
    TIFFClose(tif);
}

void TIFFOutfile::write_scanline(JSAMPARRAY out_row) {
    TIFFWriteScanline(tif, *out_row, row++);
}

