/**
Copyright Philipp Tölke, 2006-2007

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License version 2 as published by the Free
Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
St, Fifth Floor, Boston, MA  02110-1301  USA
**/

#ifndef _TIFFOUTFILE_H
#define _TIFFOUTFILE_H

#include "outfile.h"
extern "C" {
#include <jpeglib.h>
}
#include <tiffio.h>

class TIFFOutfile : public Outfile {
    public:
        TIFFOutfile();
        virtual int initialize(const char*, struct jpeg_error_mgr*, JDIMENSION, JDIMENSION, int, J_COLOR_SPACE);
        virtual ~TIFFOutfile();
        virtual void destroy();
        virtual void write_scanline(JSAMPARRAY);
    private:
        TIFF* tif;
        uint32 row;
};

#endif
